# drill-upgrade
Code to manage upgrades of data/metadata to drill data across versions. (initially for Drill 1.2 --> Drill1.3)
Upgrade_12_13.java will upgrade parquet files generated by older veresions of Drill to address DRILL-4070. This is intended to run only on Linux, on a DFS and on parquet files created by older versions of Drill.

1) Before you upgrade, backup your data

2) Limitations
  i) On a non-HDFS system, if a .crc file exists (it will if the file was created by Drill), the upgrade will not be able to update the .crc file. The only way to make things work is to delete the .crc file.

  ii) DO NOT run this on Hive (or other non-drill) generated Parquet file. Tools written using Parquet before version 1.8 had a bug that writes incorrect statistics.

3) To override the logging :
    java -Dlogback.configurationFile=/path/to/logback.xml ...


4) Usage :


$> java -Dlog.path=/path/to/logfile.log -cp drill-upgrade-1.0-jar-with-dependencies.jar org.apache.drill.upgrade.Upgrade_12_13 --tempDir=/path/to/tempdir list_of_dirs_or_files

$> java -Dlog.path=/path/to/logfile.log -cp drill-upgrade-1.0-jar-with-dependencies.jar org.apache.drill.upgrade.Upgrade_12_13  list_of_dirs_or_files

$> java -cp drill-upgrade-1.0-jar-with-dependencies.jar org.apache.drill.upgrade.Upgrade_12_13 --help

